<template>
  <div>
    <ob-modal
      ref="ob-modal"
      class="sb-popup sb-card-popup"
      :title="'Настройка поля карточки участника'"
      size="large"
      :is-center="false"
      :is-show-controls="true"
      :is-submit-disabled="!canTrySave"
      @submit="dataSubmit"
    >
      <ob-tabs ref="tabs">
        <ob-tabs-pane
          title="Общие настройки"
          :is-selected="true"
        >
          <div class="form-content">
            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-input
                  :label="'Наименование поля'"
                  :placeholder="'Например, Модель'"
                  v-model="formData.title.label"
                />
              </div>
            </div>
            <div class="row custom-row">
              <div class="col-xs-12 col-sm-4">
                <ob-input
                  :label="'Кодовое обозначение'"
                  :placeholder="'Введите обозначение'"
                  v-model="formData.code"
                />
              </div>
              <div class="col-xs-12 col-sm-4">
                <ob-selector
                  :items="dataTypesList"
                  :label="'Тип данных в поле'"
                  :placeholder="'Выберите'"
                  :value-exp="'value'"
                  v-model="formData.datatype"
                />
              </div>
              <div class="col-xs-12 col-sm-4">
                <ob-selector
                  :label="'Группа реквизитов'"
                  :placeholder="'Выберите'"
                  :remote-opt="getRequisiteGroups"
                  v-model="formData.requisite_group_uuid"
                />
              </div>
            </div>
            <div class="form-group__title">Поле актуально для</div>
            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-selector
                  :remote-opt="api.cardField.getLegalEntities"
                  :label="'Форма организации'"
                  :isMultiselect="true"
                  :isDropdown="true"
                  :placeholder="'Выберите'"
                  display-exp="title"
                  value-exp="uuid"
                  v-model="formData.legal_entity_type_uuids"
                />
              </div>
            </div>
            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-selector
                  :remote-opt="api.cardField.getCountries"
                  :label="'Страна'"
                  :placeholder="'Выберите'"
                  :isMultiselect="true"
                  :isDropdown="true"
                  :count="200"
                  :isTagbox="true"
                  :isAutoComplete="true"
                  :valueExp="'symbol_code'"
                  :displayExp="'short_title'"
                  @on-load-list="onLoadCountries"
                  v-model="formData.country_codes"
                />
              </div>
            </div>
            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-selector
                  :remote-opt="api.cardField.getRoles"
                  :label="'Роли участников'"
                  :placeholder="'Выберите'"
                  :isMultiselect="true"
                  :isDropdown="true"
                  valueExp="code"
                  v-model="formData.participant_role_codes"
                />
              </div>
            </div>
            <div class="row form-group flex-wrap jc-fs -no-horizontal-margin">
              <ob-checkbox :label="'Часть регистрации'" v-model="formData.need_for_registration" />
              <ob-checkbox :label="'Часть ключа'" v-model="formData.is_key_part" />
              <ob-checkbox
                :label="'Часть анкетных данных'"
                v-model="formData.is_questionnaire_data"
              />
              <ob-checkbox :label="'Видит только СБ'" />
              <ob-checkbox
                :label="'Оценка риска'"
                v-model="formData.need_risk_assessment"
                :disabled="isDisabledRisk"
              />
              <ob-checkbox :label="'Требуется разработка'" :value="true" :disabled="true" />
              <ob-checkbox
                :label="'Относится к персональным данным'"
                v-model="formData.is_personal_data"
              />
            </div>
          </div>
        </ob-tabs-pane>
        <ob-tabs-pane title="Источники данных">
          <div class="form-content">
            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-checkbox
                  :label="'Ручной ввод участником'"
                  v-model="formData.need_manual_filling"
                  :disabled="formData.need_for_registration"
                />
              </div>
            </div>
            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-checkbox
                  :label="'Распознавание документов'"
                  v-model="formData.need_recognition"
                  :disabled="isNew || !formData.need_recognition"
                />
              </div>
            </div>
            <div class="row custom-row" v-show="formData.need_recognition">
              <div class="col-xs-12">
                <transition name="slide-down" mode="out-in">
                  <ob-selector
                    :items="dataSource.reg_docs_for_recognitions || []"
                    :label="'Документы, которые необходимо получить от участника для заполнения поля СБшником'"
                    :placeholder="''"
                    :is-multiselect="true"
                    :is-standart="true"
                    v-model="formData.reg_docs_for_recognition_uuids"
                  />
                </transition>
              </div>
            </div>
            <div class="row custom-row" v-show="formData.need_recognition">
              <div class="col-xs-12">
                <transition name="slide-down" mode="out-in">
                  <ob-selector
                    :items="formData.recognition_services || []"
                    :label="'Сервисы для распознавания документов'"
                    :placeholder="''"
                    :is-multiselect="true"
                    :is-standart="true"
                    v-model="formData.recognition_services_uuids"
                  />
                </transition>
              </div>
            </div>
            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-checkbox
                  :label="'Ручной ввод владельцем домена'"
                  v-model="formData.need_verification"
                />
              </div>
            </div>

            <div class="row custom-row" v-show="formData.need_verification">
              <div class="col-xs-12">
                <transition name="slide-down" mode="out-in">
                  <div class="form-group">
                    <ob-selector
                      :items="dataSource.reg_docs_for_verifications || documentsList"
                      :label="'Документы'"
                      :placeholder="'Выберите документы'"
                      :isMultiselect="true"
                      v-model="formData.reg_docs_for_verification_uuids"
                    />
                  </div>
                </transition>
              </div>
            </div>

            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-checkbox
                  :label="'Внешние источники'"
                  v-model="formData.need_filling_by_external"
                  :disabled="true"
                />
              </div>
            </div>
            <div class="row custom-row" v-show="formData.need_filling_by_external">
              <div class="col-xs-12">
                <transition name="slide-down" mode="out-in">
                  <ob-selector
                    :items="dataSource.external_services || []"
                    :label="'Сервисы для получение данных'"
                    :placeholder="''"
                    :isMultiselect="true"
                    v-model="formData.external_services_uuids"
                    display-exp="title"
                    value-exp="uuid"
                    :disabled="isNew"
                  />
                </transition>
              </div>
            </div>

            <div class="row custom-row">
              <div class="col-xs-12">
                <ob-switcher-checkbox
                  :label="'Cовпадение значений обязательно'"
                  v-model="formData.need_value_match"
                />
              </div>
            </div>
          </div>
        </ob-tabs-pane>
        <ob-tabs-pane title="Допустимые значения">
          <div class="form-content">
            <div class="row">
              <div class="form-group col-xs-12 col-sm-4">
                <ob-table
                  :items="countriesForValues"
                  :columns="countryColumns"
                  :functionalPanel="false"
                  :show-add-button="true"
                  @select="onSelectedCountry"
                  @add="onClickAddCountry"
                  ref="obTable"
                />
              </div>
              <div class="col-xs-12 col-sm-8">
                <div class="row">
                  <div class="form-group col-xs-12">
                    <div class="title">{{ countrySettingsTitle }}</div>
                  </div>
                </div>
                <div class="row">
                  <template v-if="formData.country_settings && currentCountry">
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-selector
                        :items="dataTypesList"
                        :label="'Тип данных в поле'"
                        :placeholder="'Выберите'"
                        :valueExp="'value'"
                        v-model="formData.datatype"
                        :disabled="true"
                      />
                    </div>
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-selector
                        :remote-opt="api.services.getMeasurementDropdown"
                        :remote-trigger="isNumericType"
                        :label="'Единица измерения'"
                        :placeholder="'Выберите'"
                        :is-standart="true"
                        display-exp="name"
                        v-model="currentCountry.measurement_unit_uuid"
                        :disabled="formData.datatype !== 'NUMERIC'"
                      />
                    </div>
                  </template>
                </div>
                <div class="row">
                  <template v-if="formData.datatype === '2TEXT'">
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-input
                        :label="'Макс. кол-во знаков'"
                        :placeholder="'Введите значение'"
                        v-model="currentCountry.text_max_len"
                      />
                    </div>
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-input
                        :label="'Разрешенные символы'"
                        :placeholder="'Введите значение'"
                        v-model="currentCountry.text_available_symbols"
                      />
                    </div>
                    <div class="form-group col-xs-12 custom-row">
                      <ob-checkbox :label="'Использовать маску'" v-model="isMask" />
                    </div>
                    <transition name="slide-down" mode="out-in">
                      <div class="form-group" v-show="isMask">
                        <ob-input
                          :label="'Маска возможных значений'"
                          :placeholder="'Введите маску'"
                          v-model="currentCountry.text_mask"
                        />
                      </div>
                    </transition>
                  </template>
                  <template v-else-if="formData.datatype === 'NUMERIC'">
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-input
                        :label="'Макс. количество знаков'"
                        :placeholder="'Введите значение'"
                        v-model="currentCountry.numeric_max"
                      />
                    </div>
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-input
                        :label="'Кол-во знаков после запятой'"
                        :placeholder="'Введите количество'"
                        v-model="currentCountry.decimal_place_count"
                      />
                    </div>
                  </template>
                  <template v-else-if="formData.datatype === 'BOOLEAN'">
                    <div class="col-xs-12 custom-row">
                      <ob-input label="Название для варианта “Да”" value="Да" />
                    </div>
                    <div class="col-xs-12">
                      <ob-input
                        label="Название для варианта “Нет”"
                        placeholder="Введите значение"
                        value="Нет"
                      />
                    </div>
                  </template>
                  <template v-else-if="formData.datatype === 'CHECKLIST'">
                    <div class="col-xs-12 custom-row">
                      <ob-selector
                        ref="dictionariesSelector"
                        label="Наименование справочника"
                        placeholder="Выберите из списка"
                        :remote-opt="api.dictionary.dictionariesDropdown"
                        value-exp="code"
                        display-exp="title"
                        :disabled="currentCountry.country_code"
                        v-model="currentCountry.list_dict_table_name"
                      />
                    </div>
                  </template>
                  <template v-else-if="formData.datatype === 'DATE'">
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-datepicker
                        v-model="currentCountry.d_min"
                        lang="ru"
                        label="Мин. значение даты"
                        format="dd.MM.yyyy"
                      />
                    </div>
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-datepicker
                        v-model="currentCountry.d_max"
                        lang="ru"
                        label="Макс. значение даты"
                        format="dd.MM.yyyy"
                      />
                    </div>
                  </template>
                  <template v-else-if="formData.datatype === 'DATETIME'">
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-datepicker
                        v-model="currentCountry.d_min"
                        lang="ru"
                        label="Мин. значение даты-времени"
                        format="dd.MM.yyyy"
                      />
                    </div>
                    <div class="col-xs-12 col-sm-6 custom-row">
                      <ob-datepicker
                        v-model="currentCountry.d_max"
                        lang="ru"
                        label="Макс. значение даты-времени"
                        format="dd.MM.yyyy"
                      />
                    </div>
                  </template>
                </div>
              </div>
            </div>
          </div>
        </ob-tabs-pane>
        <ob-tabs-pane
          title="Оценка по умолчанию"
          :is-hidden="!formData.need_risk_assessment || isDisabledRisk"
        >
          <div class="form-content">
            <div v-for="(item, index) in currentRisks" :key="index">
              <div class="row custom-row">
                <div class="col-xs-6">
                  <ob-selector
                    label="Группа риска"
                    :placeholder="'Выберите группу риска'"
                    :items="risksGroupDropdown(item.uuid)"
                    v-model="item.uuid"
                  />
                </div>
                <template v-if="formData.datatype === 'NUMERIC'">
                  <div class="col-xs-3">
                    <ObInput
                      label="Мин"
                      v-model="item.constraints.from"
                      placeholder="Введите значение"
                    />
                  </div>
                  <div class="col-xs-3">
                    <ObInput
                      label="Макс"
                      v-model="item.constraints.to"
                      placeholder="Введите значение"
                    />
                  </div>
                </template>
                <template v-else-if="formData.datatype === 'DATE'">
                  <div class="col-xs-3">
                    <ObInput
                      label="Минимум, мес."
                      v-model="item.constraints.from"
                      placeholder="Введите значение"
                    />
                  </div>
                  <div class="col-xs-3">
                    <ObInput
                      label="Максимум, мес."
                      v-model="item.constraints.to"
                      placeholder="Введите значение"
                    />
                  </div>
                </template>
                <template v-else-if="formData.datatype === 'DATETIME'">
                  <div class="col-xs-3">
                    <ObInput
                      label="Минимум, мес."
                      v-model="item.constraints.from"
                      placeholder="Введите значение"
                    />
                  </div>
                  <div class="col-xs-3">
                    <ObInput
                      label="Максимум, мес."
                      v-model="item.constraints.to"
                      placeholder="Введите значение"
                    />
                  </div>
                </template>
                <template v-else-if="formData.datatype === 'CHECKLIST' && formData.dictionary">
                  <div class="col-xs-6">
                    <ob-selector
                      :label="formData.title.label"
                      :placeholder="'Выберите'"
                      :remote-opt="{
                          method: api.dictionary.dictionaryDropdownByType,
                          arguments: {
                            code: formData.dictionary && formData.dictionary.code
                          },
                          loadEvent: isNew && 'open'
                        }"
                      :remote-trigger="formData.dictionary && formData.dictionary.code"
                      :is-multiselect="true"
                      :is-standart="true"
                      :is-dropdown="true"
                      v-model="item.constraints.value"
                    />
                  </div>
                </template>
                <template v-else-if="formData.datatype === 'BOOLEAN'">
                  <div class="col-xs-6">
                    <ob-selector
                      :label="formData.title.label"
                      :placeholder="'Выберите'"
                      :items="booleanRisksSelector"
                      @input="setBooleanValues(item, $event)"
                      v-model="item.constraints.value"
                    />
                  </div>
                </template>
              </div>
            </div>
          </div>
        </ob-tabs-pane>
      </ob-tabs>
    </ob-modal>
  </div>
</template>

<script>
import { uuid } from 'vue-uuid';
import api from '@/api';

import ObTable from 'common-components/src/obComponents/obTable';
import ObDatepicker from 'common-components/src/obComponents/obDatePicker';
import ObModal from 'common-components/src/obComponents/obModal';
import ObSelector from 'common-components/src/obComponents/obSelect';
import ObInput from 'common-components/src/obComponents/obInput';
import ObCheckbox from 'common-components/src/obComponents/obCheckbox';
import ObSwitcherCheckbox from 'common-components/src/obComponents/obSwitcherCheckbox';
import cloneDeep from 'clone-deep';
import ObTabs from 'common-components/src/obComponents/obTabs';
import ObTabsPane from 'common-components/src/obComponents/obTabs/ObTabsPane';
import { riskGroupsProcessor, generateRisks } from '@/helpers/risks';
import { mapGetters } from 'vuex';

const countrySettings = {
  description: '',
  country_code: null,
  measurement_unit_uuid: '',
  text_min_len: null,
  text_max_len: null,
  text_available_symbols: '',
  text_masks: [],
  text_regexp: [],
  list_variant_uuids: [],
  list_dict_table_name: '',
  list_min_count: null,
  list_max_count: null,
  numeric_min: null,
  numeric_max: null,
  decimal_place_count: null,
  d_is_min_today: null,
  d_is_max_today: null,
  d_min: null,
  d_max: null,
  dt_is_min_now: null,
  dt_is_max_now: null,
  dt_min: null,
  dt_max: null
};

const formData = {
  title: {
    label: null
  },
  is_active: true,
  country_codes: [],
  code: null,
  need_for_registration: false,
  is_key_part: false,
  need_manual_filling: true,
  need_filling_by_external: false,
  need_recognition: false,
  is_questionnaire_data: false,
  need_value_match: false,
  need_verification: false,
  datatype: null,
  is_personal_data: false,
  loss_cargo_field_settings: [],
  reg_docs_for_verification_uuids: [],
  reg_docs_for_recognition_uuids: [],
  recognition_services_uuids: [],
  external_services_uuids: [],
  requisite_group_uuid: null,
  legal_entity_type_uuids: [],
  participant_role_codes: [],
  need_risk_assessment: true,
  country_settings: [
    {
      ...countrySettings
    }
  ]
};
export default {
  components: {
    ObModal,
    ObSelector,
    ObInput,
    ObCheckbox,
    ObSwitcherCheckbox,
    ObTable,
    ObDatepicker,
    ObTabs,
    ObTabsPane
  },
  data() {
    return {
      activeTab: 'settings',
      countriesPopupVisible: false,
      statusList: [],
      countriesList: [],
      companyTypesList: [],
      dataTypesList: [],
      servicesList: [],
      documentsList: [],
      dataSource: {},
      formData: cloneDeep(formData),
      isMask: false,
      countryColumns: [
        {
          key: 'short_symbol_code',
          width: 50
        },
        {
          key: 'short_title'
        }
      ],
      selectedCountry: null,
      currentRisks: [],
      currentDictionaryList: [],
      riskGroups: [],
      booleanRisksSelector: [
        {
          uuid: true,
          title: 'Да'
        },
        {
          uuid: false,
          title: 'Нет'
        }
      ],
      api
    };
  },
  computed: {
    ...mapGetters(['getCurrentLocale']),
    isNew() {
      return !this.dataSource.uuid;
    },
    canTrySave() {
      return (
        this.formData.title.label &&
        this.formData.is_active != null &&
        this.formData.datatype &&
        this.formData.participant_role_codes &&
        this.formData.participant_role_codes.length
      );
    },
    countriesForValues() {
      let countries = [];

      if (this.formData.country_codes && this.formData.country_codes.length) {
        countries = this.countriesList.filter(country => {
          return this.formData.country_codes.includes(country.symbol_code);
        });
      }

      return [
        {
          uuid: null,
          short_title: 'Все страны',
          symbol_code: null
        },
        ...countries
      ];
    },
    currentCountry() {
      let code = this.selectedCountry ? this.selectedCountry.symbol_code : null;
      return this.formData.country_settings.find(
        item => item.country_code === code
      );
    },
    countrySettingsTitle() {
      if (!this.selectedCountry || !this.selectedCountry.symbol_code)
        return 'Для всех стран';
      else return this.selectedCountry.short_title;
    },
    isDisabledRisk() {
      return !['BOOLEAN', 'CHECKLIST', 'DATE', 'DATETIME', 'NUMERIC'].includes(
        this.formData.datatype
      );
    },
    isNumericType() {
      return this.formData && this.formData.datatype === 'NUMERIC';
    },
    addedRisksUuids() {
      return this.currentRisks ? this.currentRisks.map(item => item.uuid) : [];
    }
  },
  async mounted() {
    this.fetchData();
  },
  watch: {
    'formData.need_for_registration': function(val) {
      this.formData.need_manual_filling = val;
    },
    'formData.country_codes': function(codes) {
      let allValue =
        this.formData.country_settings.find(item => !item.country_code) ||
        countrySettings;
      if (!codes || !codes.length) {
        this.formData.country_settings = [{ ...cloneDeep(allValue) }];
        this.selectedCountry = null;
      } else {
        let allValue =
          this.formData.country_settings.find(item => !item.country_code) ||
          cloneDeep(countrySettings);

        let result = [
          {
            ...allValue
          }
        ];

        codes.forEach(code => {
          let value = this.formData.country_settings.find(
            item => item.country_code === code
          );
          let country = this.countriesList.find(
            item => item.symbol_code === code
          );
          let initialValue = this.formData.country_settings.find(
            item => !item.country_code
          );
          if (!value) {
            value = {
              ...cloneDeep(initialValue),
              country_code: code,
              uuid: country && country.uuid
            };
          }

          result.push(value);
        });

        this.formData.country_settings = result;

        if (
          this.selectedCountry &&
          this.selectedCountry.symbol_code &&
          !codes.includes(this.selectedCountry.symbol_code)
        ) {
          this.selectedCountry = null;
        }
      }
    },
    'formData.datatype': function(type) {
      this.initRisksData(type);
    },
    'currentCountry.list_dict_table_name': async function(code) {
      if (this.$refs.dictionariesSelector) {
        let items = this.$refs.dictionariesSelector.localItems || [];
        this.formData.dictionary = items.find(item => item.code === code);

        this.currentRisks.forEach(item => {
          if (item.constraints) {
            item.constraints.value = [];
          }
        });
      }
    }
  },
  methods: {
    initRisksData(type) {
      if (this.isDisabledRisk) {
        this.formData.need_risk_assessment = false;
      }

      if (
        (this.formData.uuid &&
          this.formData.risks_list &&
          this.formData.risks_list.length) ||
        this.isDisabledRisk
      )
        return;

      let riskGroups =
        this.formData.datatype === 'BOOLEAN'
          ? this.riskGroups.filter(item =>
              ['GREEN', 'BLACK'].includes(item.color)
            )
          : this.riskGroups;
      this.currentRisks = generateRisks({ data: riskGroups, type });
    },
    async fetchData() {
      try {
        this.dataTypesList = [
          { key: 1, title: 'Число', value: 'NUMERIC' },
          { key: 2, title: 'Строка', value: 'TEXT' },
          { key: 3, title: 'Логический', value: 'BOOLEAN' },
          { key: 3, title: 'Чеклист', value: 'CHECKLIST' },
          { key: 3, title: 'Дата', value: 'DATE' },
          { key: 3, title: 'Время', value: 'DATETIME' }
        ];

        this.documentsList = await api.cardField.getDocs({
          type: 'participant'
        });

        this.statusList = [
          { key: 1, value: true, title: 'Активно' },
          { key: 0, value: false, title: 'Выключено' }
        ];

        this.riskGroups = await api.card.getRiskGroups();
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    async dataSubmit() {
      let notificationId = new Date().getTime() + 'save';
      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        });
        const isUpdate = this.formData.uuid || false;

        this.formData.uuid = this.formData.uuid || uuid.v4();

        delete this.formData.recognition_services;
        delete this.formData.reg_docs_for_recognitions;
        delete this.formData.external_services;
        delete this.formData.reg_docs_for_recognitions;
        delete this.formData.reg_docs_for_verifications;
        delete this.formData.requisite_group;
        delete this.formData.legal_entity_type;

        let currentLocale = this.getCurrentLocale;
        if (currentLocale) {
          this.formData.title[currentLocale] = this.formData.title.label;
        }

        let risks = this.addedRisksUuids.map((uuid, index) => {
          let item = this.riskGroups.find(item => item.uuid === uuid);
          let {
            participant_payment_risk_group_uuid,
            cargo_loss_risk_group_uuid
          } = item;
          return {
            is_active: true,
            role_code: '',
            cargo_loss_risk_group_uuid,
            participant_payment_risk_group_uuid,
            constraints: this.currentRisks[index].constraints
          };
        });

        isUpdate
          ? await api.cardField.update(this.formData)
          : await api.cardField.create(this.formData);
        if (this.formData.need_risk_assessment) {
          await api.card.setRiskGroups({
            uuid: this.formData.uuid,
            riskValues: risks
          });
        }

        this.$emit('saved');
        this.$refs['ob-modal'].close();
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        });
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        });
      } finally {
        this.$notification({ event: 'close', id: notificationId });
      }
    },

    setTab(tabName) {
      this.activeTab = tabName;
    },
    open(data = {}) {
      this.dataSource = data;
      if (data.country_codes) {
        data.country_codes = data.country_codes.map(item => item.toLowerCase());
      }

      data.requisite_group_uuid =
        (data.requisite_group && data.requisite_group.uuid) || null;
      data.external_services_uuids =
        data.external_services && data.external_services.length
          ? data.external_services.map(item => item.uuid)
          : [];

      data.reg_docs_for_recognition_uuids =
        data.reg_docs_for_recognitions && data.reg_docs_for_recognitions.length
          ? data.reg_docs_for_recognitions.map(item => item.uuid)
          : [];
      data.reg_docs_for_verification_uuids =
        data.reg_docs_for_verifications &&
        data.reg_docs_for_verifications.length
          ? data.reg_docs_for_verifications.map(item => item.uuid)
          : [];
      data.recognition_services_uuids =
        data.recognition_services && data.recognition_services.length
          ? data.recognition_services.map(item => item.uuid)
          : [];

      data.legal_entity_type_uuids =
        data.legal_entity_type && data.legal_entity_type.length
          ? data.legal_entity_type.map(item => item.uuid)
          : [];

      if (data.datatype === 'CHECKLIST') {
        data.dictionary = {
          code: data.country_settings[0].list_dict_table_name
        };
      }

      this.formData = { ...cloneDeep(formData), ...data };

      this.formData.need_risk_assessment = !this.isDisabledRisk;

      if (data.risks_list && data.risks_list.length) {
        this.currentRisks = riskGroupsProcessor({
          data: data.risks_list || []
        });
      } else {
        this.initRisksData(data.datatype);
      }

      this.$refs['ob-modal'].open();

      this.$nextTick(() => {
        this.$refs['tabs'].selected = { title: 'Общие настройки' };
      });
    },
    onClickAddCountry() {
      alert('add click');
    },
    onSelectedCountry(data) {
      this.selectedCountry = data;
    },
    onLoadCountries(data) {
      this.countriesList = data;
    },
    async getRequisiteGroups() {
      try {
        let content = await api.cardField.getRequisiteGroups();
        return content.filter(item => item.type === 'participant');
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    risksGroupDropdown(uuid) {
      return this.riskGroups.filter(item => item.uuid === uuid);
    },
    setBooleanValues(item, value) {
      let siblingsItem = this.currentRisks.find(
        risk => risk.uuid !== item.uuid
      );
      if (siblingsItem && siblingsItem.constraints) {
        siblingsItem.constraints.value = !value;
      }
    }
  }
};
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/mixins';

.form-content {
  padding-top: 20px;
}

.custom-row {
  margin-bottom: 20px;
}
.form-group {
  justify-content: space-between;
  align-self: flex-start;
  & > .ob-select-container {
    width: 100%;
  }
  & > div {
    & + div:not(.checkbox-wrapper) {
      margin-left: 20px;
    }
  }

  .checkbox-wrapper {
    margin-right: 30px;
    margin-bottom: 10px;
  }

  .title {
    @include font-mixin(16px, 18px, 400, $organizationsCardConstructorPage-popup_title);
    margin-bottom: 20px;
  }

  &__title {
    @include font-mixin(16px, 24px, 700, $organizationsCardConstructorPage-popup_title, 0.4px);
    margin-bottom: 10px;
  }

  .date-wrap {
    margin: 0;
  }
}

.flex-wrap {
  flex-wrap: wrap;
}

.jc-fs {
  justify-content: flex-start;
}

.mb20 {
  margin-bottom: 20px;
}

.-no-horizontal-margin {
  margin-left: 0;
  margin-right: 0;
}
</style>

<style lang="scss">
.switch-tabs {
  margin-bottom: 30px;

  button {
    width: auto;
    margin-right: 10px;
    padding-left: 10px;
    padding-right: 10px;
    border-radius: 3px;
  }
}

.icon.risk {
  .risk-level-0 & {
    color: $color-green-light;
  }

  .risk-level-1 & {
    color: $light-denim;
  }

  .risk-level-2 & {
    color: $gorse-yellow;
  }

  .risk-level-3 & {
    color: $diamond-orange-yellow;
  }

  .risk-level-4 & {
    color: $color-error;
  }

  .risk-level-5 & {
    color: $color-text-base;
  }
}

.sb-card-popup {
  .dx-datagrid-headers {
    display: none;
  }

  .data-grid__header {
    margin: 0;
    border: 1px solid
      $organizationsCardConstructorPage-popup_data-grid_header_border;
  }

  .data-grid__table {
    min-height: 400px;
    max-height: 400px;
  }
}

.slide-down-enter-active,
.slide-down-leave-active {
  transition: all 0.4s;
  max-height: 999px;
}

.slide-down-enter, .slide-down-leave-to /* .fade-leave-active до версии 2.1.8 */
{
  max-height: 0;
  opacity: 0;
}

.al-i-fs {
  align-items: flex-start !important;
}
</style>


